//
// Kagi_Ind_Trade.mq4                                                          . 
//  , , sk@autograf.dp.ua, ICQ 64015987, http://autograf.dp.ua
// 0 
#property copyright "Copyright SK AutoGraf  2008"
#property link      "http://autograf.dp.ua/"
//================================================================================== 1 ==
#property indicator_chart_window                //    
#property indicator_buffers 8                   //   8

extern int Delta     = 31;                      //    
extern int Method    = 1;                       //   
extern int Period_MA = 34;                      //  
extern int TimeFrame = 15;                      // 

int Width = 2;                                  //   
extern color Color_1 = DodgerBlue;              //  1
extern color Color_2 = OrangeRed;               //  2

double Gor_B[];                                 //   .    
double Gor_S[];                                 //   .  

int   Vector,                                   //  
      Tip,                                      //   (/)
      Last_V,                                   //   
      BB, SS,                                   //    Buy  Sell       
      Rez,                                      //    
      Ord;                                      //    

double delta,                                   //      
       Revers,                                  //   
       Pr_Min,                                  //     
       Pr_Max,                                  //    
       Last_Min,                                //      
       Last_Max,                                //     
       bb,                                      //     Buy
       ss;                                      //     Sell
// 3 
int init()
   {
//================================================================================== 4 ==
   SetIndexBuffer(0,Gor_B);                     //     . 
   SetIndexBuffer(1,Gor_S);                     //     . 
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,Width,Color_1); //    
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,Width,Color_2); //    

   delta = Delta*Point;                         //   
//================================================================================== 8 ==
   return;
   }
// 9 
int start()
   {
//================================================================================= 10 ==
   int 
      counted_bars,                             //   
      i;                                        //  
   double Data;
   string
      Ts_Name;                                  //  . 
//================================================================================= 11 ==
   counted_bars=IndicatorCounted();             //   
   i=Bars-counted_bars-1;                       //    

   if (counted_bars == 0)                       //     start()
      {
      if (Close[i]>Open[i])                     //  
         {
         Tip = 0;                               //   = ,  Buy
         Vector = 1;                            //  - 
         Pr_Min=MathMin(Close[i]-delta,Open[i]);//   
         Pr_Max = Close[i];                     //   
         Last_Min = Pr_Max;                     //      
         Last_Max = Pr_Max;                     //     
         bb = Open[i];
         }
      else                                      //  
         {
         Tip = 1;                               //   = ,  Sell
         Vector = -1;                           //  - 
         Pr_Max=MathMax(Close[i]+delta,Open[i]);//   
         Pr_Min = Close[i];                     //   
         Last_Min = Pr_Min;                     //      
         Last_Max = Pr_Min;                     //     
         ss = Open[i];
         }
      Last_V = i;                               //   
      }
//================================================================================= 12 ==
   while(i>=1)                                  //    
      {
      static int First=0;                       //     1 
      if (i==1)                                 //   1 
         {
         if (First==1)                          //      1 
            Last_V++;                           //      1
         First=1;                               //  :    
         }
//--------------------------------------------------------------------------------- 13 --
      switch(Method)                            //   
         {
         case 1:  Data = iMA(NULL,TimeFrame,Period_MA,0,MODE_SMMA,PRICE_TYPICAL,i); break;
         default: Data = Close[i];
         }
//--------------------------------------------------------------------------------- 14 --
      if (Gor_B[i+1] != EMPTY_VALUE)            //    ..
         Gor_B[i]=Close[i];                     // ..    
      else
         Gor_B[i]=EMPTY_VALUE;                  // ..    
         
      if (Gor_S[i+1] != EMPTY_VALUE)            //    ..
         Gor_S[i]=Close[i];                     // ..    
      else
         Gor_S[i]=EMPTY_VALUE;                  // ..    

      switch(Tip)                               //     
         {
//================================================================================= 15 ==
         case 1:                                         //  
            switch(Vector)                               //  
               {
//--------------------------------------------------------------------------------- 16 --
               case -1:                                  //  (  )
                  if (NormalizeDouble(Data-Last_Min,Digits)<0.0)
                     Last_Min = Data;
                  if (NormalizeDouble(Data-(Last_Min+delta),Digits)>=0.0)//
                     {
                     Vector = 1;                         //  - 
                     Pr_Min = Last_Min;                  //   
                     Last_Max = Data;   
                     Last_V = i;                         //   
                     if (NormalizeDouble(Last_Max-Pr_Max,Digits)>0.0)//  
                        {
                        Tip = 0;                         //    
                        Gor_B[i]=Close[i];               //   
                        Gor_S[i]=EMPTY_VALUE;            //   
                        }
                     }   
                  break;
//--------------------------------------------------------------------------------- 17 --
               case 1:                                   // 
                  if (NormalizeDouble(Data-Last_Max,Digits)>0.0)
                     {
                     Last_Max = Data;
                     if (NormalizeDouble(Last_Max-Pr_Max,Digits)>0.0)//  
                        {
                        Tip = 0;                         //    
                        Gor_B[i]=Close[i];               //   
                        Gor_S[i]=EMPTY_VALUE;            //   
                        }
                     }
                  if (NormalizeDouble(Data-(Last_Max-delta),Digits)<=0.0)//.
                     {
                     Vector = -1;                        //  - 
                     Pr_Max = Last_Max;                  //   
                     Last_Min = Data;                    //  
                     Last_V = i;                         //   
                     }
                  break;
//--------------------------------------------------------------------------------- 18 --
               }
            break;
//================================================================================= 19 ==
         case 0:                                         //  
            switch(Vector)                               //  
               {
//--------------------------------------------------------------------------------- 20 --
               case 1:                                   //  (  )
                  if (NormalizeDouble(Data-Last_Max,Digits)>0.0)
                     Last_Max = Data;
                  if (NormalizeDouble(Data-(Last_Max-delta),Digits)<=0.0)//
                     {
                     Vector = -1;                        //  - 
                     Pr_Max = Last_Max;                  //   
                     Last_Min = Data;   
                     Last_V = i;                         //   
                     if (NormalizeDouble(Last_Min-Pr_Min,Digits)<0.0)//  
                        {
                        Tip = 1;                         //    
                        Gor_S[i]=Close[i];               //   
                        Gor_B[i]=EMPTY_VALUE;            //   
                        }
                     }   
                  break;
//--------------------------------------------------------------------------------- 21 --
               case -1:                                  // 
                  if (NormalizeDouble(Data-Last_Min,Digits)<0.0)
                     {
                     Last_Min = Data;
                     if (NormalizeDouble(Last_Min-Pr_Min,Digits)<0.0)//  
                        {
                        Tip = 1;                         //    
                        Gor_S[i]=Close[i];               //   
                        Gor_B[i]=EMPTY_VALUE;            //   
                        }
                     }
                  if (NormalizeDouble(Data-(Last_Min+delta),Digits)>=0.0)//.
                     {
                     Vector = 1;                         //  - 
                     Pr_Min = Last_Min;                  //   
                     Last_Max = Data;                    //  
                     Last_V = i;                         //   
                     }
                  break;
//--------------------------------------------------------------------------------- 22 --
               }
            break;
//================================================================================= 23 ==
         }
      i--;
      }
//================================================================================= 29 ==
   return;
   }
//    45 